  (function($){

    
    $.belowthefold = function(element, settings) {
        var fold = $(window).height() + $(window).scrollTop();
        return fold <= $(element).offset().top - settings.threshold;
    };

    $.abovethetop = function(element, settings) {
        var top = $(window).scrollTop();
        return top >= $(element).offset().top + $(element).height() - settings.threshold;
    };
    
    $.rightofscreen = function(element, settings) {
        var fold = $(window).width() + $(window).scrollLeft();
        return fold <= $(element).offset().left - settings.threshold;
    };
    
    $.leftofscreen = function(element, settings) {
        var left = $(window).scrollLeft();
        return left >= $(element).offset().left + $(element).width() - settings.threshold;
    };
    
    $.inviewport = function(element, settings) {
        return !$.rightofscreen(element, settings) && !$.leftofscreen(element, settings) && !$.belowthefold(element, settings) && !$.abovethetop(element, settings);
    };
    
    $.extend($.expr[':'], {
        "below-the-fold": function(a, i, m) {
            return $.belowthefold(a, {threshold : 0});
        },
        "above-the-top": function(a, i, m) {
            return $.abovethetop(a, {threshold : 0});
        },
        "left-of-screen": function(a, i, m) {
            return $.leftofscreen(a, {threshold : 0});
        },
        "right-of-screen": function(a, i, m) {
            return $.rightofscreen(a, {threshold : 0});
        },
        "in-viewport": function(a, i, m) {
            return $.inviewport(a, {threshold : 0});
        }
    });

    
    $.fn.visible = function(partial){
        var $t				= $(this),
          $w				= $(window),
          viewTop			= $w.scrollTop(),
          viewBottom		= viewTop + $w.height(),
          _top			= $t.offset().top,
          _bottom			= _top + $t.height(),
          compareTop		= partial === true ? _bottom : _top,
          compareBottom	= partial === true ? _top : _bottom;

      return ((compareBottom <= viewBottom) && (compareTop >= viewTop));
    };

  })(jQuery);
    var liveSearchConfig = JSON.parse(document.getElementById('km_live_search_config').innerHTML);
    var overlayclosed = false;
    var kmqs = getCache('qs');
    var kmminoffset = parseInt(getCache('minoffset'));
    if (isNaN(kmminoffset)) kmminoffset = 0;
    var searchval = null;
    var minval = liveSearchConfig.searchminsigns;
    var searchTimeout;
    
    function setCache(cname, cvalue) {
      cname = 'kmlivesearch'+cname;
      sessionStorage.setItem(cname, cvalue);
    }
    function getCache(cname) {
      cname = 'kmlivesearch'+cname;
      var cvalue = sessionStorage.getItem(cname);
      return cvalue;
    }
    function clearCache() {
      sessionStorage.clear();
    }
    
    function livesearch() {
      var val = $('#km-live-search input[name=livesearch]').val();
      searchval = val;
      $("#km-live-search-container").html('');
      var requrl = "/index.php";
      var reqdata = {
        isAjax: "1",
        func: "km_live_search",
        s: val,
        ao: kmminoffset
      };
      var onsuccess = function(data) {
        $("#km-live-search-container").html(data);
        setCache('qs', val);
      }
      $.ajax({
        url: requrl,
        dataType: 'html',
        data: reqdata,
        success: onsuccess,
        timeout: 3000
      });
    };
    
    function getMinViewportOffset() {
      var min = null;
      $('#km-live-search-result-article .product-wrapper .product-offset:in-viewport').each(function(pos, el) {
        if (min === null || parseInt(el.dataset.offset) < min) {
          min = parseInt(el.dataset.offset);
        }
      });
      return min === null ? 0 : min;
    }
    
    $(document).ready(function() {
      $("#km-live-search-logo").hide();
      $('#km-live-search input[name=livesearch]').on("keyup paste", function() {
        saveStorageData();
        if (searchTimeout) clearTimeout(searchTimeout);
        var val = $('#km-live-search input[name=livesearch]').val();
        if (val.length >= minval) {
          // clear offset
          setCache('minoffset', 0);
          kmminoffset = 0;
          
          searchTimeout = setTimeout(livesearch, 300);
        }
      });
      var searchStarted = false;
      $(document).on("click",'.show-more-link',function(event){
        if(searchStarted === false) {
          searchStarted = true;
          var parts = $(event.target).attr('id').split('-');
          $("#km-live-search-result-"+parts[1]+" .show-more-link").addClass('loading');
          var requrlmore = "/index.php";
          var charnext = parts[1].substr(0, 1);
          var offsetkey = charnext+'o';
          var reqdatamore = {
            isAjax: "1",
            func: "km_live_search",
            s: searchval,
            next: charnext
          };
          reqdatamore[offsetkey] = parts[2];
          var onsuccessmore = function(data) {
            $("#km-live-search-result-"+parts[1]+" .show-more-link").remove();
            $("#km-live-search-result-"+parts[1]+" .km-live-search-result-area-inside div.km-flex").append(data);
            $("#km-live-search-result-"+parts[1]+" .km-live-search-result-area-inside ul").append(data);
            searchStarted = false;
          }
          $.ajax({
            url: requrlmore,
            dataType: 'html',
            data: reqdatamore,
            success: onsuccessmore,
            timeout: 3000
          });
        }
      });
      $(document).on("click",'.show-prev-link',function(event){
        if(searchStarted === false) {
          searchStarted = true;
          var prevcontext = $(event.target).attr('data-context');
          var prevoffset  = $(event.target).attr('data-offset');
          var prevlimit   = $(event.target).attr('data-limit');
          $("#km-live-search-result-"+prevcontext+" .show-prev-link").addClass('loading');
          var requrlprev  = "/index.php";
          var charprev    = prevcontext.substr(0, 1);
          var offsetkey   = charprev+'o';
          var limitkey    = charprev+'l';
          var reqdataprev = {
            isAjax: "1",
            func: "km_live_search",
            s: searchval,
            prev: charprev
          };
          reqdataprev[offsetkey] = prevoffset;
          reqdataprev[limitkey]  = prevlimit;
          var onsuccessprev = function(data) {
            $("#km-live-search-result-"+prevcontext+" .show-prev-link").remove();
            $("#km-live-search-result-"+prevcontext+" .km-live-search-result-area-inside div.km-flex").prepend(data);
            $("#km-live-search-result-"+prevcontext+" .km-live-search-result-area-inside ul").prepend(data);
            searchStarted = false;
          }
          $.ajax({
            url: requrlprev,
            dataType: 'html',
            data: reqdataprev,
            success: onsuccessprev,
            timeout: 3000
          });
        }
      });
    });
      
      function openOverlay() {
        $('#km-live-search').addClass("km-overlay");
        $("#km-live-search-logo").show();
        $("body").addClass("overflow-hidden");
        $('#km-live-search input[name=livesearch]').focus();
        storeUri();
        addHistoryState(null, null, 'kmls');
      }
      
      function closeOverlay() {
        $("#km-live-search-container").empty();
        $('#km-live-search').removeClass("km-overlay");
        $("#km-live-search-logo").hide();
        $("body").removeClass("overflow-hidden");
        overlayclosed = true;
        addHistoryStateFromStore();
      }
      
      function saveStorageData() {
        setCache('qs', $('#km-live-search input[name=livesearch]').val());
      }
      
      function loadStorageData() {
        kmqs = getCache('qs');
        $('#km-live-search input[name=livesearch]').val(kmqs);
        if (searchTimeout) clearTimeout(searchTimeout);
        var val = $('#km-live-search input[name=livesearch]').val();
        if (val.length >= minval) {
          // clear offset
          setCache('minoffset', 0);
          searchTimeout = setTimeout(livesearch, 300);
        }
      }
      
      function addHistoryState(descr, title, pathsuffix) {
        if (!descr)      descr = 'kmlivesearch';
        if (!title)      title = 'Suche';
    
        if (pathsuffix) pathsuffix = '#'+pathsuffix
    
        pathsuffix = window.location.protocol+"//"+window.location.host+window.location.pathname+pathsuffix;
    
        history.pushState({descriptor: descr}, title, pathsuffix);
      }
    
      function addHistoryStateFromStore() {
        var descr = 'lastfromstore';
        history.pushState({descriptor: descr}, restoreTitle(), restoreUri());
      }
    
      function storeUri() {
        setCache('lasturi', window.location.protocol+"//"+window.location.host+window.location.pathname);
        setCache('lastdoctitle', document.title);
      }
    
      function restoreUri() {
        return getCache('lasturi');
      }
    
      function restoreTitle() {
        return getCache('lastdoctitle');
      }
      
      function overlayIsOpen(){
        return $('#km-live-search').hasClass("km-overlay");
      }
    
      $(document).ready(function() {
        if (window.location.hash == '#kmls') {
          openOverlay();
          loadStorageData();
        }
        if (window.location.hash == '#kmlsclear') {
          clearCache();
          window.location.href = '/';
        }
      });
    
      window.onpopstate = function(e) {
        if (overlayclosed === true) {
          openOverlay();
          loadStorageData();
        }
      }
    
      $(liveSearchConfig.seltrigger).click( function() {
        if (overlayIsOpen() === false) {
          openOverlay();
          loadStorageData();
        }
      });

      $('#km-live-search input[name=livesearch]').focus( function() {
        if (overlayIsOpen() === false) {
          openOverlay();
          loadStorageData();
        }
      });
      $('#km-live-search').submit(function(e){
        e.preventDefault();
      });
      $('#km-live-search-close').click( function() {
        saveStorageData();
        closeOverlay();
      });
    $('#km-live-search').scroll(function(){
      setCache('minoffset', getMinViewportOffset());
      if ($('#km-live-search-result-article .show-more-link').length > 0) {
        if($('#km-live-search-result-article .show-more-link').visible()) {
          $('#km-live-search-result-article .show-more-link span').trigger( "click" );
        }
      }
    });